Index: branches/fscctrl_safety_limits/src/fscctrl.cc
===================================================================
--- branches/fscctrl_safety_limits/src/fscctrl.cc	(revision 18341)
+++ branches/fscctrl_safety_limits/src/fscctrl.cc	(revision 18342)
@@ -41,5 +41,16 @@
     vector<Interpolator2D::vec> fPositionsSensors;
     vector<Interpolator2D::vec> fPositionsBias;
-    FSC::SecurityCurrentLimits fSecurityCurrentLimits;
+
+    double fEthernetSwitchCurrentLimit;
+    double fFFCcurrentLimit;
+    double fFLPcurrentLimit;
+    double fFADdigitalCurrentLimit;
+    double fFADnegativeCurrentLimit;
+    double fFADpositiveCurrentLimit;
+    double fFPAdigitalCurrentLimit;
+    double fFPAnegativeCurrentLimit;
+    double fFPApositiveCurrentLimit;
+
+
     bool fSecurityLimitsExceeded;
 
@@ -628,14 +639,14 @@
         
         const double current_limits[] = {
-            fSecurityCurrentLimits.FAD_digital, 
-            fSecurityCurrentLimits.FAD_positive, 
-            fSecurityCurrentLimits.FAD_negative, 
-            fSecurityCurrentLimits.FPA_digital, 
-            fSecurityCurrentLimits.FPA_positive, 
-            fSecurityCurrentLimits.FPA_negative,
-            fSecurityCurrentLimits.ethernet_switch,
+            fFADdigitalCurrentLimit,
+            fFADnegativeCurrentLimit,
+            fFADpositiveCurrentLimit,
+            fFPAdigitalCurrentLimit,
+            fFPAnegativeCurrentLimit,
+            fFPApositiveCurrentLimit,
+            fEthernetSwitchCurrentLimit,
             INFINITY,
-            fSecurityCurrentLimits.FFC,
-            fSecurityCurrentLimits.FLP,
+            fFFCcurrentLimit,
+            fFLPcurrentLimit,
             };
         
@@ -806,7 +817,47 @@
     }
 
-    void SetSecurityCurrentLimits(const FSC::SecurityCurrentLimits &lim)
-    {
-        fSecurityCurrentLimits = lim;
+    void SetEthernetSwitchCurrentLimit(double lim)
+    {
+        fEthernetSwitchCurrentLimit = lim;
+    }
+    
+    void SetFFCcurrentLimit(double lim)
+    {
+        fFFCcurrentLimit = lim;
+    }
+    
+    void SetFLPcurrentLimit(double lim)
+    {
+        fFLPcurrentLimit = lim;
+    }
+    
+    void SetFADdigitalCurrentLimit(double lim)
+    {
+        fFADdigitalCurrentLimit = lim;
+    }
+    
+    void SetFADnegativeCurrentLimit(double lim)
+    {
+        fFADnegativeCurrentLimit = lim;
+    }
+    
+    void SetFADpositiveCurrentLimit(double lim)
+    {
+        fFADpositiveCurrentLimit = lim;
+    }
+    
+    void SetFPAdigitalCurrentLimit(double lim)
+    {
+        fFPAdigitalCurrentLimit = lim;
+    }
+    
+    void SetFPAnegativeCurrentLimit(double lim)
+    {
+        fFPAnegativeCurrentLimit = lim;
+    }
+    
+    void SetFPApositiveCurrentLimit(double lim)
+    {
+        fFPApositiveCurrentLimit = lim;
     }
 
@@ -1136,15 +1187,13 @@
         fFSC.SetPositionsBias(v2);
 
-        FSC::SecurityCurrentLimits lim;
-        lim.ethernet_switch = conf.Get<double>("ethernet_switch");
-        lim.FFC = conf.Get<double>("FFC");
-        lim.FLP = conf.Get<double>("FLP");
-        lim.FAD_digital = conf.Get<double>("FAD_digital");
-        lim.FAD_negative = conf.Get<double>("FAD_negative");
-        lim.FAD_positive = conf.Get<double>("FAD_positive");
-        lim.FPA_digital = conf.Get<double>("FPA_digital");
-        lim.FPA_negative = conf.Get<double>("FPA_negative");
-        lim.FPA_positive = conf.Get<double>("FPA_positive");
-        fFSC.SetSecurityCurrentLimits(lim);
+        fFSC.SetEthernetSwitchCurrentLimit( conf.Get<double>("ethernet_switch") );
+        fFSC.SetFFCcurrentLimit( conf.Get<double>("FFC") );
+        fFSC.SetFLPcurrentLimit( conf.Get<double>("FLP") );
+        fFSC.SetFADdigitalCurrentLimit( conf.Get<double>("FAD_digital") );
+        fFSC.SetFADnegativeCurrentLimit( conf.Get<double>("FAD_negative") );
+        fFSC.SetFADpositiveCurrentLimit( conf.Get<double>("FAD_positive") );
+        fFSC.SetFPAdigitalCurrentLimit( conf.Get<double>("FPA_digital") );
+        fFSC.SetFPAnegativeCurrentLimit( conf.Get<double>("FPA_negative") );
+        fFSC.SetFPApositiveCurrentLimit( conf.Get<double>("FPA_positive") );
 
         SetEndpoint(conf.Get<string>("addr"));